\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{dvplan}[2009/05/06]
\LoadClass[letter]{article}

\usepackage[margin=1in,nohead]{geometry}

\setcounter{secnumdepth}{4}
\setcounter{tocdepth}{2}
\newcounter {subsubsubsection}[subsubsection]
\renewcommand\thesubsubsubsection{\thesubsubsection .\@arabic\c@subsubsubsection}
\newcommand\subsubsubsection{\@startsection{subsubsubsection}{4}{\z@}%
                                     {-3.25ex\@plus -1ex \@minus -.2ex}%
                                     {1.5ex \@plus .2ex}%
                                     {\normalfont\normalsize\bfseries}}
\newcommand*\l@subsubsubsection{\@dottedtocline{4}{3.8em}{3.2em}}

\newcommand{\planowner}[1]{\gdef\@planowner{#1}}
\newcommand{\planreviewer}[1]{\gdef\@planreviewer{#1}}
\newcommand{\planreviewversion}[1]{\gdef\@planreviewversion{#1}}
\newcommand{\planreviewdate}[1]{\gdef\@planreviewdate{#1}
                               \begin{tabular}{ l l }
                                  Owner: & \@planowner \\
                                  Reviewer: & \@planreviewer \\
                                  Reviewed Version: & \@planreviewversion \\
                                  Review Date: & \@planreviewdate \\
                               \end{tabular}
                               \linebreak}

\newcommand{\planfeature}[1]{ \section{Feature: #1} }
\newcommand{\planinterface}[1]{ \subsection{Interface: #1} }
\newcommand{\planblockimpact}{ \subsection{Impacted Blocks} }
\newcommand{\planintfimpact}{ \subsection{Impacted Interfaces} }
\newcommand{\planfeatureimpact}{ \subsection{Impacted Features} }
\newcommand{\planrequirements}{ \subsection{Requirements} }
\newcommand{\plantbcomponents}{ \subsection{Testbench Components} }
\newcommand{\plangatesim}{ \subsection{Gate Simulation Considerations} }

\newcommand{\plansection}[1]{ \subsubsection{#1} }
\newcommand{\plansubsection}[1]{ \subsubsubsection{#1} }

\newcommand{\planrequirement}[1]{\gdef\@planrequirement{#1}}
\newcommand{\planrequire}[1]{\gdef\@planrequire{#1}}
\newcommand{\planrequirestage}[1]{\gdef\@planrequirestage{#1}}
\newcommand{\planrequirechecker}[1]{\gdef\@planrequirechecker{#1}}
\newcommand{\planrequirecoverage}[1]{\gdef\@planrequirecoverage{#1}
                         \begin{tabular}{|p{1.5in}|l|l|}
                             \hline
                             Requirement: \@planrequirement \linebreak Stage: \@planrequirestage & \multicolumn{2}{p{4.5in}|}{\@planrequire} \\
                             \hline
                             \multicolumn{2}{|c|}{Checker} & \multicolumn{1}{c|}{Coverage} \\
                             \hline
                             \multicolumn{2}{|l|}{\@planrequirechecker} & \@planrequirecoverage \\
                             \hline
                         \end{tabular}
                         \linebreak
                         \linebreak}
\newcommand{\require}[4]{Ask Ryan how to get rid of the 'Evil Red Text' and use the new Requirment Styles
                         \linebreak
                         Requirement: #1
                         \linebreak
                         Description: #2
                         \linebreak
                         Checker:#3
                         \linebreak
                         Coverage: #4
                         \linebreak}

\newcommand{\planconfig}{ \subsubsection{Configurations} }
\newcommand{\plantransactions}{ \subsubsection{Transactions} }
\newcommand{\plantransactionsequences}{ \subsubsection{Transaction Sequences} }
\newcommand{\planeventsynchronization}{ \subsubsection{Event Synchronization} }
\newcommand{\planfaulthandling}{ \subsubsection{Fault Handling} }

\newcommand{\planclocksresets}{ \subsubsection{Clocks \& Resets} }
\newcommand{\plandataintegrity}{ \subsubsection{Data Integrity} }
\newcommand{\plantransformations}{ \subsubsection{Transformations} }
\newcommand{\plantransformationsequences}{ \subsubsection{Transformation Sequences} }
\newcommand{\planrouting}{ \subsubsection{Routing} }

\newcommand{\planhvlcomponents}{ \subsubsection{HVL Components} }
\newcommand{\plancppcomponents}{ \subsubsection{C/C++ Components} }
\newcommand{\planscripts}{ \subsubsection{Scripts} }
\newcommand{\planfiles}{ \subsubsection{Files} }
